#ifndef IP_NAT_H
#define IP_NAT_H 

/**/
#define IP_OPT_R2_1		0x88
#define IP_OPT_R2_2		0x8A
#define IP_OPT_R2_3		0x8B

#define IP_R2_MTU			1152
#define IP_R2_MTU_CTRL		128
#define IP_R2_MTU_DATA		1024

/**/
typedef struct ip_nat_dst {
	ipaddr_t	ipv4;
	u32_t		ip_opt_flags;
	/* base or generic address space */
	/* store option first 2 bytes to work with memcpy */
	union{
		u8_t		ip_opt_b45[8];
	}b;
	/* user addr space */
	union{
		u8_t		ip_opt_u12[4];
	}u;
	/* IPv6 addr space */
	union{
		u8_t		ip_opt_v6[20];
	}v;
}ip_nat_dst_t;

typedef struct ip_nat {
	ipaddr_t		loc;
	ip_nat_dst_t	dst;
}ip_nat_t;

/* ip_opt_flags bits*/
#define IP_NAT_R2_EN_B45	(0x000001U)
#define IP_NAT_R2_EN_U12	(0x000100U)
#define IP_NAT_R2_EN_V6		(0x010000U)

/**/
typedef struct init_ip_nat_dst {
	const char		*ipv4;
	const char		*ip_opt_b45;
	const char		*ip_opt_u12;
	const char		*ip_opt_v6;
}init_ip_nat_dst_t;

typedef struct init_ip_nat {
	const char			*loc;
	init_ip_nat_dst_t	dst;
}init_ip_nat_t;

/**/
typedef struct ip_nat_ps_hdr_tcp{
	ipaddr_t	not_old_ih_src;
	ipaddr_t	not_old_ih_dst;
	ipaddr_t	new_ih_src;
	ipaddr_t	new_ih_dst;
}ip_nat_ps_hdr_tcp_t;

typedef struct ip_nat_ps_hdr_udp{
	ipaddr_t	not_old_ih_src;
	ipaddr_t	not_old_ih_dst;
	ipaddr_t	new_ih_src;
	ipaddr_t	new_ih_dst;
}ip_nat_ps_hdr_udp_t;

#endif
